---
title: "Get Return Index view"
url: "https://developer-beta.morningstar.com/apis/investment-details-api/versions/1101e487-2040-43e8-8548-06647294be56/operations/getReturnIndexPackage"
---

> Full API specification: https://developer-beta.morningstar.com/apis/investment-details-api/versions/1101e487-2040-43e8-8548-06647294be56.md

# Get Return Index view

`GET` `/direct-web-services/v1/investments/{id}/return-index`

Operation ID: `getReturnIndexPackage`

Most recent data supported.

## Path parameters

- `id` (string, required) - Specifies the investment to query. Morningstar Performance ID is the default identifer for the API. Use the Universe API to retrieve Performance IDs for investments in your entitled universe.

## Query parameters

- `idType` (string, optional) - Specifies the type of the value passed in the `id` parameter. Morningstar Performance ID is the default identifer for the API. Use the Universe API to retrieve Performance IDs for investments in your entitled universe.
- `baseCurrency` (string, optional) - Base currency to use for investment lookup. Accepts 3‑character ISO 4217 currency codes.
- `domicile` (string, optional) - Domicile to use for investment lookup. Accepts 3-character ISO 3166-1 country codes.
- `exchangeCountry` (string, optional) - Exchange country to use for investment lookup. Accepts 3-character ISO 3166-1 country codes.
- `exchangeId` (string, optional) - Exchange identifier to use for investment lookup.
- `currencyId` (string, optional) - Currency identifier in ISO format (e.g., "USD", "EUR", "GBP")

## Responses

- `200` - OK
- `400` - Bad Request
- `500` - Internal Server Error

## OpenAPI definition

```yaml
openapi: 3.1.0
info:
  title: Investment Details API
  version: "1.0"
servers:
  - url: https://www.us-api.morningstar.com
    description: Americas
  - url: https://www.apac-api.morningstar.com
    description: APAC
  - url: https://www.emea-api.morningstar.com
    description: EMEA
paths:
  /direct-web-services/v1/investments/{id}/return-index:
    get:
      summary: Get Return Index view
      parameters:
        - name: id
          in: path
          description: >-
            
            Specifies the investment to query. 

            Morningstar Performance ID is the default identifer for the API. Use
            the Universe API to retrieve Performance IDs for investments in your
            entitled universe.
          required: true
          schema:
            type: string
            example: 0P00000046
          examples:
            performanceId:
              summary: Morningstar Performance ID
              value: 0P00000046
            isin:
              summary: ISIN
              value: US0042391096
        - name: idType
          in: query
          description: >-
            Specifies the type of the value passed in the `id` parameter.

            Morningstar Performance ID is the default identifer for the API. Use
            the Universe API to retrieve Performance IDs for investments in your
            entitled universe.
          schema:
            enum:
              - performanceId
              - isin
              - securityId
              - cusip
              - tradingSymbol
              - fundCode
              - msid
            type: string
            default: performanceId
        - name: baseCurrency
          in: query
          description: Base currency to use for investment lookup. Accepts 3‑character ISO
            4217 currency codes.
          schema:
            type: string
          examples:
            baseCurrencyExample1:
              summary: US Dollar
              value: USD
            baseCurrencyExample2:
              summary: Swiss Franc
              value: CHF
        - name: domicile
          in: query
          description: Domicile to use for investment lookup. Accepts 3-character ISO
            3166-1 country codes.
          schema:
            type: string
          examples:
            domicileExample1:
              summary: CAN (Canada)
              value: CAN
            domicileExample2:
              summary: JPN (Japan)
              value: JPN
            domicileExample3:
              summary: USE (United States)
              value: USA
        - name: exchangeCountry
          in: query
          description: Exchange country to use for investment lookup. Accepts 3-character
            ISO 3166-1 country codes.
          schema:
            type: string
          examples:
            exchangeCountryExample1:
              summary: CAN (Canada)
              value: CAN
            exchangeCountryExample2:
              summary: JPN (Japan)
              value: JPN
            exchangeCountryExample3:
              summary: USA (USA)
              value: USA
        - name: exchangeId
          in: query
          description: Exchange identifier to use for investment lookup.
          schema:
            type: string
            externalDocs:
              description: List of exchange IDs.
              url: https://developer.morningstar.com/content/hidden-from-navigation/DwsIdLookUpExchangeIds.xlsx
          examples:
            exchangeIdExample1:
              summary: NASDAQ - ALL Markets (NAS)
              value: EX$$$$XNAS
            exchangeIdExample2:
              summary: London Stock Exchange (LSE)
              value: EX$$$$XLON
        - name: currencyId
          in: query
          description: Currency identifier in ISO format (e.g., "USD", "EUR", "GBP")
          schema:
            type: string
      description: Most recent data supported.
      operationId: getReturnIndexPackage
      tags:
        - Investment Details
      responses:
        "200":
          $ref: "#/components/responses/ResponseReturnIndex"
        "400":
          $ref: "#/components/responses/ResponseBadRequest"
        "500":
          $ref: "#/components/responses/ResponseInternalServerError"
      x-cpqId: 57
security:
  - Bearer: []
components:
  responses:
    ResponseReturnIndex:
      description: OK
      content:
        application/json:
          schema:
            $ref: "#/components/schemas/ResponseReturnIndex"
    ResponseBadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: "#/components/schemas/OutputErrorDetails"
    ResponseInternalServerError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: "#/components/schemas/OutputErrorDetails"
  schemas:
    ResponseReturnIndex:
      type: object
      properties:
        returnIndex:
          $ref: "#/components/schemas/OutputReturnIndex"
        identifiers:
          $ref: "#/components/schemas/OutputIdentifiers"
        metadata:
          $ref: "#/components/schemas/OutputMetadata"
    OutputErrorDetails:
      type: object
      properties:
        statusCode:
          type: integer
          description: Status Code
          format: int32
        errorCode:
          type: string
          description: Custom error code
          nullable: true
        message:
          type: string
          description: Message
          nullable: true
        requestId:
          type: string
          description: RequestId
          nullable: true
      additionalProperties: false
      description: Error details
      title: OutputErrorDetails
    OutputReturnIndex:
      type: object
      properties:
        cumFairNavUnweightedDri:
          type: number
          description: ""
          format: double
          nullable: true
        cumFairNavUnweightedDriDate:
          type: string
          description: ""
          nullable: true
        cumFairNavWeightedDri:
          type: number
          description: ""
          format: double
          nullable: true
        cumFairNavWeightedDriDate:
          type: string
          description: ""
          nullable: true
        exParNavUnweightedDri:
          type: number
          description: ""
          format: double
          nullable: true
        exParNavUnweightedDriDate:
          type: string
          description: ""
          nullable: true
        exParNavWeightedDri:
          type: number
          description: ""
          format: double
          nullable: true
        exParNavWeightedDriDate:
          type: string
          description: ""
          nullable: true
        navUnweightedDri:
          type: number
          description: ""
          format: double
          nullable: true
        navUnweightedDriDate:
          type: string
          description: ""
          nullable: true
        navWeightedDri:
          type: number
          description: ""
          format: double
          nullable: true
        navWeightedDriDate:
          type: string
          description: ""
          nullable: true
        priceUnweightedDri:
          type: number
          description: ""
          format: double
          nullable: true
        priceUnweightedDriDate:
          type: string
          description: ""
          nullable: true
        priceWeightedDri:
          type: number
          description: ""
          format: double
          nullable: true
        priceWeightedDriDate:
          type: string
          description: ""
          nullable: true
      additionalProperties: false
      title: OutputReturnIndex
      description: All fields are nullable. Empty or `null` value fields are not returned.
    OutputIdentifiers:
      type: object
      properties:
        performanceId:
          type: string
          nullable: true
        securityId:
          type: string
          nullable: true
        cusip:
          type: string
          nullable: true
        isin:
          type: string
          nullable: true
        sedol:
          type: string
          nullable: true
        tradingSymbol:
          type: string
          nullable: true
        fundCode:
          type: string
          nullable: true
        msid:
          type: string
          nullable: true
        ticker:
          type: string
          nullable: true
      additionalProperties: false
      title: OutputIdentifiers
      description: All fields are nullable. Empty or `null` value fields are not returned.
    OutputMetadata:
      type: object
      properties:
        requestId:
          type: string
          nullable: true
        time:
          type: string
          format: date-time
          readOnly: true
        portfolioDate:
          type: string
          nullable: true
        portfolioCurrency:
          type: string
          nullable: true
        messages:
          type: array
          items:
            $ref: "#/components/schemas/OutputMetadataMessages"
          nullable: true
      additionalProperties: false
      title: OutputMetadata
      description: All fields are nullable. Empty or `null` value fields are not returned.
    OutputMetadataMessages:
      type: object
      properties:
        type:
          type: string
          nullable: true
        code:
          type: string
          nullable: true
        investments:
          type: array
          items:
            $ref: "#/components/schemas/OutputInvalidInvestments"
          nullable: true
        message:
          type: string
          nullable: true
      additionalProperties: false
      title: OutputMetadataMessages
      description: All fields are nullable. Empty or `null` value fields are not returned.
    OutputInvalidInvestments:
      type: object
      properties:
        id:
          type: string
          nullable: true
        idType:
          type: string
          nullable: true
        status:
          type: string
          nullable: true
        datapointId:
          type: array
          items:
            type: string
          nullable: true
        customDatapoints:
          type: array
          items:
            type: string
          nullable: true
        errorCode:
          type: string
          nullable: true
        performanceId:
          type: string
          description: Performance ID (if not passed in request).
          nullable: true
        companyId:
          type: string
          description: Company ID (if not passed in request).
          nullable: true
        baseCurrency:
          type: string
          description: Input base currency used to look up Investment identifier
          nullable: true
        domicile:
          type: string
          description: Input domicile used to look up Investment identifier.
          nullable: true
        exchangeCountry:
          type: string
          description: Input exchange country used to look up Investment identifier.
          nullable: true
        exchangeId:
          type: string
          description: Input exchange id used to look up Investment identifier.
          nullable: true
      additionalProperties: false
      title: OutputInvalidInvestments
      description: All fields are nullable. Empty or `null` value fields are not returned.
  securitySchemes:
    Bearer:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: "JWT obtained from `POST /token/oauth`. Send it on every request as
        `Authorization: Bearer <token>`. Reuse the token for up to 60 minutes,
        then request a new one."
```
